#!/usr/bin/perl -w

use strict;
use warnings;

use CGI qw(header -no_debug);
use Mail::POP3Client;
use MIME::Base64;
use CGI::WebOut;

my $file_form = "../html/mail_form.htm";    
my $header    = "<html><head><title>POP3 Web Interface</title></head><body>";    
my $end       = "</body></html>";
    
my $repeat    = <<REP_FORM;
 			<form action='/cgi-bin/mail_reader.pl' method='POST'>                                        
            	<input type='hidden' name='user' value=%%user%%> 		                       
                <input type='hidden' name='pass' value=%%pass%%> 		                       
                <input type='hidden' name='server' value=%%serv%%> 		                       
                <input type='hidden' name='param' value='ok'> 		     		   
                <input type='submit' name='subm' value='Repeat'> 
	        </form>
REP_FORM
			
my $delete   = <<DEL_FORM;
			<form action='/cgi-bin/mail_reader.pl' method='POST'>                                        
            	<input type='hidden' name='user' value=%%user%%> 		                       
                <input type='hidden' name='pass' value=%%pass%%> 		                       
                <input type='hidden' name='server' value=%%serv%%> 		                       
                <input type='hidden' name='param' value='del'> 		     		   
                <input type='submit' name='subm' value='Delete all'> 
	        </form> 									 
DEL_FORM
 
my $q    = CGI->new();
my $form = &read_file($file_form);
 
if($q->param('param')) {
  	my $login = $q->param('user');
  	my $password = $q->param('pass');
  	my $mailserver = $q->param('server');
 
  	my $pop = new Mail::POP3Client(	USER     => $login,
    	                            PASSWORD => $password,
                                  	HOST     => $mailserver, 
							     	#DEBUG    => 1,
									TIMEOUT  => 60);

	my $count = $pop->Count();
															
  	if ($count == -1 ) {
   		print "    !<br>\n" . $pop->State() . "\n" . $pop->Message() . "<br>\n";
	 	exit(0);
  	} 
	 
	 
	if($q->param('del')) {
		for(my $i = 1; $i <= $count; $i++ ) {
			$pop->delete($i);
		}	  
	}
	 
   	print $header . $form ;
	print <<COUNT;
		<fieldset>
			<legend><b>Number of messages</b></legend>
			<p align='left'>You have <b>$count</b> messages on [<b>$mailserver</b>] for user [<b>$login</b>].</p>
		</fieldset>
		

COUNT
	 
	print <<HEAD;
		<fieldset>
		<legend><b>List Of Messages</b></legend>
		<table border='0' align='center' cellpadding='3' cellspacing='3' width='98%' style='font-size: 12px;'>
	    	<tr bgcolor='#5D5D5D' style='color: white; font-weight: bolder;' align='center'>
		    	<th width='30px'>No</th><th width='20%'>From</th><th width='*'>Subject</th><th width='15%'>Date</th></tr>
HEAD
	 
	for(my $i = 1; $i <= $count; $i++ ) {
		print "<tr bgcolor='".($i%2 ? '#E8E8E8' : '#B9B9B9')."'><td align='center'>$i</td>";
     	
		my ($from, $subj, $date);
		foreach ( $pop->Head( $i ) ) {
			if(/delivery-date:\s+\w{3},(.*?)\+/i) { $date = $1 }
			elsif(/^from:\s+(.*)/i) { $from = $1 }	
			elsif(/^subject:\s+(.*)/i) { $subj = $1 }
		}
	
		print "<td><b>$from</b></td><td>$subj</td><td align='center'>$date</td></tr>"; 
	}
	
	$pop->Close(); 
  	
	print "</table></fieldset>";
  
  	$repeat =~ s/%%user%%/$login/;
  	$repeat =~ s/%%pass%%/$password/;
  	$repeat =~ s/%%serv%%/$mailserver/;	
	$delete =~ s/%%user%%/$login/;
  	$delete =~ s/%%pass%%/$password/;
  	$delete =~ s/%%serv%%/$mailserver/;
  
  	print <<FOOTER;
		<fieldset>
		<legend><b>Operations</b></legend>
		<table><tr><td>$repeat</td><td>$delete</td></tr></table>
		</fieldset>
		$end
FOOTER

} else {
	print $header . $form . $end;
}

#############################################

sub read_file {
	my $fname = shift;
   	my $str = "";
    
	open FORM, $fname or die "Can't open file $fname: $!";
    
	while(<FORM>) {
		$str .= $_;
	}
    
	close FORM or die "Can't open file $fname: $!";
   
   	return "<fieldset><legend><b>POP3 web interface</b></legend>$str</fieldset>";
}

__END__
